"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Commander = void 0;
// tslint:disable:no-console
var chalk = require("chalk");
var cli = require("commander");
var fs = require("fs-extra");
var glob = require("glob");
var path = require("path");
var commander_1 = require("./commander");
var modules_1 = require("./modules");
var Commander = /** @class */ (function () {
    function Commander() {
    }
    Commander.prototype.ioc = function (iocContainer) {
        (0, commander_1.setIocContainer)(iocContainer);
        return this;
    };
    Commander.prototype.commandsFromDirectory = function (directoryPath) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var pattern = path.join(directoryPath, '**/*.@(js|ts)');
                        glob(pattern, function (err, matches) {
                            if (err) {
                                return reject(err);
                            }
                            var moduleFileNames = (0, modules_1.getUniqueModuleNames)(matches);
                            for (var _i = 0, moduleFileNames_1 = moduleFileNames; _i < moduleFileNames_1.length; _i++) {
                                var moduleFileName = moduleFileNames_1[_i];
                                require(moduleFileName);
                            }
                            resolve(_this);
                        });
                    })];
            });
        });
    };
    Commander.prototype.version = function (version) {
        this._version = version;
        return this;
    };
    Commander.prototype.versionFromPackage = function (directoryPath) {
        this._version = this.getPackageVersion(path.resolve(directoryPath, './package.json'));
        return this;
    };
    Commander.prototype.execute = function (argv) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var args, err_1, errorMessage;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this._version) {
                            cli.program.version(this._version);
                        }
                        args = argv || process.argv;
                        cli.program.addHelpText('after', '\n');
                        if (args.length <= 2) {
                            cli.program.outputHelp();
                            return [2 /*return*/];
                        }
                        cli.program.on('command:*', function () {
                            console.error();
                            console.error('Invalid command: %s\nSee --help for a list of available commands.', cli.program.args.join(' '));
                            console.error();
                            process.exitCode = 1;
                        });
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, cli.program.parseAsync(args)];
                    case 2:
                        _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _b.sent();
                        process.exitCode = 1;
                        console.error();
                        errorMessage = (_a = err_1.message) !== null && _a !== void 0 ? _a : err_1;
                        console.error(chalk.red(errorMessage));
                        console.error();
                        throw err_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Commander.prototype.getPackageVersion = function (packageFileName) {
        var exists = fs.pathExistsSync(packageFileName);
        if (!exists) {
            throw new Error('Could not find package.json to load version from');
        }
        var packageObject = fs.readJSONSync(packageFileName);
        var version = packageObject && packageObject.version;
        return version;
    };
    return Commander;
}());
exports.Commander = Commander;
