"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.value = exports.option = exports.command = void 0;
var commander_1 = require("./commander");
var meta = require("./metadata");
var command = function (name, paramsClass, description) {
    return function (target) {
        (0, commander_1.registerCommand)({
            name: name,
            description: description,
            type: target,
            paramsClass: paramsClass,
        });
    };
};
exports.command = command;
var option = function (options) { return function (target, name) {
    meta.addCommandOption(target, name, options);
}; };
exports.option = option;
var value = function (options) { return function (target, name) {
    meta.addCommandValue({
        name: name,
        paramsClassPrototype: target,
        optional: !!(options && options.optional),
        variadicType: options && options.variadic && options.variadic.type
    });
}; };
exports.value = value;
