import { Commander } from './classy';
import { CommandClass, IocContainer } from './types';
export { command, option, value } from './decorators';
export { Command, CommandValueDefinition, CommandOptionDefinition, CommandOptionDefinitionOptions, IocContainer } from './types';
export declare function version(version: string): Commander;
export declare function versionFromPackage(dirName: string): Commander;
export declare function ioc(container: IocContainer): Commander;
/**
 * Loads all commands within a directory so you don't need to require them individually.
 * @param directoryPath Directory path of the commands.
 */
export declare function commandsFromDirectory(directoryPath: string): Promise<Commander>;
export declare function execute(argv?: string[]): Promise<void>;
export declare function getCommandUsageString(commandClass: CommandClass<any>): string;
