"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addCommandOption = exports.getCommandOptions = exports.addCommandValue = exports.getCommandValues = exports.metadataKeys = void 0;
require("reflect-metadata");
exports.metadataKeys = Object.freeze({
    command: Symbol('command'),
    options: Symbol('options'),
    values: Symbol('values')
});
function getCommandValues(paramsClassPrototype) {
    return __spreadArray([], (Reflect.getOwnMetadata(exports.metadataKeys.values, paramsClassPrototype) || []), true);
}
exports.getCommandValues = getCommandValues;
function addCommandValue(options) {
    var name = options.name, optional = options.optional, paramsClassPrototype = options.paramsClassPrototype, variadicType = options.variadicType;
    var type = variadicType || Reflect.getMetadata('design:type', paramsClassPrototype, name);
    var variadic = !!variadicType;
    var values = getCommandValues(paramsClassPrototype);
    if (variadic && values.some(function (value) { return value.variadic; })) {
        throw new Error('Command can have only one variadic value');
    }
    values.push({
        name: name,
        type: type,
        optional: optional,
        variadic: variadic
    });
    Reflect.defineMetadata(exports.metadataKeys.values, values, options.paramsClassPrototype);
}
exports.addCommandValue = addCommandValue;
function getCommandOptions(paramsClassPrototype) {
    return __spreadArray([], (Reflect.getOwnMetadata(exports.metadataKeys.options, paramsClassPrototype) || []), true);
}
exports.getCommandOptions = getCommandOptions;
function addCommandOption(paramsClassPrototype, name, options) {
    var type = Reflect.getMetadata('design:type', paramsClassPrototype, name);
    var allOptions = getCommandOptions(paramsClassPrototype);
    allOptions.push(__assign({ name: name, type: type }, options));
    Reflect.defineMetadata(exports.metadataKeys.options, allOptions, paramsClassPrototype);
}
exports.addCommandOption = addCommandOption;
