"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUniqueModuleNames = void 0;
var _ = require("lodash");
function isFileNameTypeScriptOrJavaScript(fileName) {
    return /.\.(ts|js)$/i.test(fileName);
}
function isFileNameDeclarationFile(fileName) {
    return /\.d.ts$/i.test(fileName);
}
function removeFileExtension(fileName) {
    return fileName.slice(0, -3);
}
function getUniqueModuleNames(fileNames) {
    var moduleNames = _
        .chain(fileNames)
        .filter(function (fileName) { return !isFileNameDeclarationFile(fileName); })
        .filter(isFileNameTypeScriptOrJavaScript)
        .map(removeFileExtension)
        .uniq()
        .value();
    return moduleNames;
}
exports.getUniqueModuleNames = getUniqueModuleNames;
